;================================================================================================================================================================================
; Format the passed string to the correct field length for printing
;================================================================================================================================================================================

Procedure.s FormatField(InString.s, FieldLen.i)

  ;------------------------------------------------------------------------------------------------
  ; Get the length of the input string
  ;------------------------------------------------------------------------------------------------

  InStringLen.i = Len(InString.s)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the number of spaces required to format the field minus the string length
  ;------------------------------------------------------------------------------------------------
  
  SpaceLen.i    = FieldLen.i - InStringLen.i

  ;------------------------------------------------------------------------------------------------
  ; Add the string, format character and spaces together
  ;------------------------------------------------------------------------------------------------
  
  If SpaceLen.i > 1
  
    OutString.s = InString.s + ": " + Space(SpaceLen.i)
  
  Else
  
    OutString.s = InString.s + ": "
  
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Return the formatted value back to the user
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn OutString.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableXP