;============================================================================================================================================================
; Save all preferences at program end
;============================================================================================================================================================

Procedure SavePreferencesFile()
  
  ;------------------------------------------------------------------------------------------------
  ; If the INI file doesn't exist, create a default one
  ;------------------------------------------------------------------------------------------------
  
  If FileSize(Program\InitialisationFile.s) = -1

    CreatePreferencesFile()

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If OpenPreferences(Program\InitialisationFile.s) <> #BadPreferencesFile
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    PreferenceGroup("Program Options")
    
    ;----------------------------------------------------------------------------------------------
    ; Program Toggles
    ;----------------------------------------------------------------------------------------------
    
    WritePreferenceString("Last Directory Searched",  Program\LastDirectorySearched.s)
  
    WritePreferenceString("Last String Searched",     Program\LastStringSearched.s)
  
    WritePreferenceLong("Snap To Screen",             Program\ScreenSnap.i)
  
    WritePreferenceLong("Tool Tips",                  Program\ToolTips.i)
  
    WritePreferenceLong("Title Clock",                Program\TitleClock.i)
    
    WritePreferenceLong("Sticky Window",              Program\StickyWindow.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClosePreferences()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Headings",  "Error",  "Preferences file missing or damaged", #PB_Compiler_Procedure)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 64
; FirstLine = 28
; Folding = -
; DisableDebugger
; HideErrorLog