﻿;==========================================================================================================================================================
; Visual designer generated
;==========================================================================================================================================================

XIncludeFile "Recipeview_Constants.pb"                                                                ; Visual designer generated
XIncludeFile "Recipeview_Windows.pb"                                                                  ; Visual designer generated

;==========================================================================================================================================================
; My personal constants, declarations etc
;==========================================================================================================================================================

XIncludeFile "Recipeview_MyDeclarations.pb"                                                           ; My procedural declarations
XIncludeFile "Recipeview_MyConstants.pb"                                                              ; My personal constants

;==========================================================================================================================================================
; Third part routines with multiple code points
;==========================================================================================================================================================

XIncludeFile "Modules\ThirdParty\_NM_Hover.pbi"                                                       ; NetMaestro's Hover library

;==========================================================================================================================================================
; Custom procedures
;==========================================================================================================================================================

XIncludeFile "Modules\Custom\_BalloonToolTip.pbi"                                                     ; Add balloon tooltips with individual fonts and icons
XIncludeFile "Modules\Custom\_GetIconHandle.pbi"                                                      ; Copy the icon into memory while deleting the original image copied from
XIncludeFile "Modules\Custom\_SetDate.pbi"                                                            ; Sort out the date and display it
XIncludeFile "Modules\Custom\_SetHoverIcons.pbi"                                                      ; Set the correct icons to the selected hoverable gadget
XIncludeFile "Modules\Custom\_StatusBarButtonTip.pbi"                   ; Menu, shortcut language     ; Set and display button toolbar/menu text in the statusbar
XIncludeFile "Modules\Custom\_TitleClock.pbi"                                                         ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_WindowCallback.pbi"                                                     ; Window snap, strikeoutfont and more
XIncludeFile "Modules\Custom\_WordWrapString.pbi"                                                     ; Wrap a string to a specified boundary

;==========================================================================================================================================================
; Generic procedures
;==========================================================================================================================================================

XIncludeFile "Modules\Generic\_FormatField.pbi"                                                       ; Format the passed string to the correct field length for printing
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                   ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                          ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                     ; Remove borders from various gadgets

;==========================================================================================================================================================
; Program helpers
;==========================================================================================================================================================

XIncludeFile "Modules\Helpers\_GetRecipeDirectory.pbi"                                                ; Scan recipe directory and load filenames
XIncludeFile "Modules\Helpers\_SetInfoBarArea.pbi"                                                    ; Handle the fake statusbar area messages

;==========================================================================================================================================================
; Recipe related procedures
;==========================================================================================================================================================

XIncludeFile "Modules\Recipes\_SearchEngine.pbi"                                                      ; Search and list recipes from a directory
XIncludeFile "Modules\Recipes\_SearchRecipes.pbi"                                                     ; Search recipes in linked list and display matches
XIncludeFile "Modules\Recipes\_ShowRecipe.pbi"                                                        ; Load the recipe into the webgadget to display it

;==============================================================================================================================================================================
; Various program toggles
;==============================================================================================================================================================================

XIncludeFile "Modules\Toggles\_ToggleScreenSnap.pbi"                                                  ; Turn snapping to screen borders on and off
XIncludeFile "Modules\Toggles\_ToggleToolTips.pbi"                                                    ; Turn tool tips on and off as needed
XIncludeFile "Modules\Toggles\_ToggleTitleClock.pbi"                                                  ; Turn time updating on in the title bar
XIncludeFile "Modules\Toggles\_ToggleStickyWindow.pbi"                                                ; Set this window on top of others or alarm window will not show

;==========================================================================================================================================================
; Preference file handling
;==========================================================================================================================================================

XIncludeFile "Modules\Preferences\_CreatePreferencesFile.pbi"                                         ; Create a brand new INI file in the program directory if the default one is missing, with default values.
XIncludeFile "Modules\Preferences\_ReadPreferencesFile.pbi"                                           ; Read the system preferences file or create it if missing
XIncludeFile "Modules\Preferences\_SavePreferencesFile.pbi"                                           ; Save all preferences at program end

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

If Window_Recipeview()
  
  ;//**********************************************************************************************
  ;// 
  ;//**********************************************************************************************
  
  Program\QuitValue = #False
  
  ;//**********************************************************************************************
  ;// Read startup preferences.
  ;//**********************************************************************************************
  
  ReadPreferencesFile()

  ;//**********************************************************************************************
  ;// Add keyboard shortcuts
  ;//**********************************************************************************************
  
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_StartSearching,  #Shortcut_RecipeView_StartSearching)
  
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_GetRecipes,      #Shortcut_RecipeView_GetRecipes)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_PrintRecipe,     #Shortcut_RecipeView_PrintRecipe)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_ScreenSnap,      #Shortcut_RecipeView_ScreenSnap)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_ToolTips,        #Shortcut_RecipeView_ToolTips)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_TitleClock,      #Shortcut_RecipeView_TitleClock)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_StickyWindow,    #Shortcut_RecipeView_StickyWindow)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_HelpProgram,     #Shortcut_RecipeView_HelpProgram)
  AddKeyboardShortcut(#Window_Recipeview, #Keys_RecipeView_ExitProgram,     #Shortcut_RecipeView_ExitProgram)
  
  ;//**********************************************************************************************
  ;// Remove the ListIconGadget borders
  ;//**********************************************************************************************
  
  RemoveBorders(#Gadget_Recipeview_Recipenames)
  
  ;//**********************************************************************************************
  ;// These are your balloon tooltips used on the main form. All headings, balloon text and icons are
  ;// re-useable variables taken from the constants file.
  ;//**********************************************************************************************
  
  If Program\BalloonFontId
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_Getdirectory,   Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_GetRecipes,     #CRLF$ + GetShortCutText(#Keys_RecipeView_GetRecipes)     + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_GetRecipes,     30),  GetIconHandle(#Image_Recipeview_Getdirectory))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_Printrecipe,    Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_PrintRecipe,    #CRLF$ + GetShortCutText(#Keys_RecipeView_PrintRecipe)    + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_PrintRecipe,    30),  GetIconHandle(#Image_Recipeview_Printrecipe))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_ScreenSnap,     Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_ScreenSnap,     #CRLF$ + GetShortCutText(#Keys_RecipeView_ScreenSnap)     + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_ScreenSnap,     30),  GetIconHandle(#Image_Recipeview_Screensnap))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_ToolTips,       Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_ToolTips,       #CRLF$ + GetShortCutText(#Keys_RecipeView_ToolTips)       + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_ToolTips,       30),  GetIconHandle(#Image_Recipeview_Tooltips))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_TitleClock,     Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_TitleClock,     #CRLF$ + GetShortCutText(#Keys_RecipeView_TitleClock)     + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_TitleClock,     30),  GetIconHandle(#Image_Recipeview_Titleclock))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_StickyWindow,   Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_StickyWindow,   #CRLF$ + GetShortCutText(#Keys_RecipeView_StickyWindow)   + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_StickyWindow,   30),  GetIconHandle(#Image_Recipeview_Stickywindow))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_Showhelp,       Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_HelpProgram,    #CRLF$ + GetShortCutText(#Keys_RecipeView_HelpProgram)    + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_HelpProgram,    30),  GetIconHandle(#Image_Recipeview_Showhelp))
    BalloonToolTip(#Window_Recipeview, #Gadget_Recipeview_Exitprogram,    Program\BalloonFontId, $FFFFFF, ShortKey\RecipeView_ExitProgram,    #CRLF$ + GetShortCutText(#Keys_RecipeView_ExitProgram)    + #CRLF$ + #CRLF$ + WordWrapString(LongKey\RecipeView_ExitProgram,    30),  GetIconHandle(#Image_Recipeview_Exitprogram))
  Else
    MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
  EndIf
  
  ;//**********************************************************************************************
  ;// Turn on the title bar clock
  ;//**********************************************************************************************
  
  If Program\TitleClock = #False
    Program\TitleClock = #True
  ElseIf Program\TitleClock = #True
    Program\TitleClock = #False
  EndIf

  ToggleTitleClock()  
  
  ;//**********************************************************************************************
  ;// Turn on snapping to window borders
  ;//**********************************************************************************************
  
  If Program\ScreenSnap = #False
    Program\ScreenSnap = #True
  ElseIf Program\ScreenSnap = #True
    Program\ScreenSnap = #False
  EndIf
    
  ToggleScreenSnap()
  
  ;//**********************************************************************************************
  ;// Turn on or off window tooltips
  ;//**********************************************************************************************
  
  If Program\ToolTips = #False
    Program\ToolTips = #True
  ElseIf Program\ToolTips = #True
    Program\ToolTips = #False
  EndIf
  
  ToggleToolTips()
  
  ;//**********************************************************************************************
  ;// Turn on or off sticky window
  ;//**********************************************************************************************
  
  If Program\StickyWindow = #False
    Program\StickyWindow = #True
  ElseIf Program\StickyWindow = #True
    Program\StickyWindow = #False
  EndIf
  
  ToggleStickyWindow()
  
  ;//**********************************************************************************************
  ;// Colours, resizing and more callback
  ;//**********************************************************************************************
  
  SetWindowCallback(@WindowCallback())
  
  ;//**********************************************************************************************
  ;// Turn on mouse event hover testing, this is NetMaestro's code.
  ;//**********************************************************************************************
  
  InitHoverEvents(#Window_Recipeview)
  
  ;//**********************************************************************************************
  ;// Add the hovering effect to the category buttons
  ;//**********************************************************************************************
  
  AddHoverGadget(GadgetID(#Gadget_Recipeview_Getdirectory))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_Printrecipe))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_ScreenSnap))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_ToolTips))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_TitleClock))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_StickyWindow))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_Showhelp))
  AddHoverGadget(GadgetID(#Gadget_Recipeview_Exitprogram))
  
  ;//**********************************************************************************************
  ;// Limit the number of search box characters and set the cue banner text. These variables are set in the Recipeview_Myconstants file.
  ;//**********************************************************************************************
  
  SendMessage_(GadgetID(#Gadget_Recipeview_Recipesearch), #EM_SETLIMITTEXT, 67, 0)
  SendMessage_(GadgetID(#Gadget_Recipeview_Recipesearch), #EM_SETCUEBANNER,  1,  Program\SearchCueText)
  
  ;//**********************************************************************************************
  ;// Set initial search string font to be italic font
  ;//**********************************************************************************************
  
  SetGadgetFont(#Gadget_Recipeview_Recipesearch, FontID(Program\SearchCueFont))
  
  ;//**********************************************************************************************
  ;// Load the recipes from the last used recipe directory
  ;//**********************************************************************************************
  
  If Program\LastDirectorySearched.s  <>  #Empty$
    
    If FileSize(Program\LastDirectorySearched.s) = #FileIsDirectory
      
      SetGadgetText(#Gadget_Recipeview_Recipedirectory, Program\LastDirectorySearched.s)
    
      SearchEngine(Program\LastDirectorySearched.s)
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Last used recipe directory cannot be found", #PB_Compiler_Procedure)
      
    EndIf
  
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "The last used recipe directory is empty", #PB_Compiler_Procedure)
    
  EndIf

  ;//**********************************************************************************************
  ;// Setup initial welcome dialogues in the fake statusbar area
  ;//**********************************************************************************************
  
  SetInfoBarArea("Headings",  "Welcome",    "Welcome to " + #Fish + #Basename + #Version + Program\CompileCounters  + ", Have a nice day")
  SetInfoBarArea("Current",   #Empty$, "0")
  SetInfoBarArea("Records",   #Empty$, Str(CountGadgetItems(#Gadget_Recipeview_Recipenames)))
  
  ;//**********************************************************************************************
  ;// Set main window and search box active
  ;//**********************************************************************************************
  
  SetActiveWindow(#Window_Recipeview)
  SetActiveGadget(#Gadget_Recipeview_Recipesearch)
  
  ;//**********************************************************************************************
  ;// Main event handler
  ;//**********************************************************************************************
  
  Repeat
    
    ;//********************************************************************************************
    ;// 
    ;//********************************************************************************************
    
    EventID  =  WaitWindowEvent()
    MenuID   =  EventMenu()
    GadgetID =  EventGadget()
    WindowID =  EventWindow()
    
    ;//********************************************************************************************
    ;// 
    ;//********************************************************************************************
    
    Select EventID
   
    ;//********************************************************************************************
    ;// 
    ;//********************************************************************************************
        
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_Recipeview                     : Program\QuitValue  = #True
        EndSelect
        
        ;//****************************************************************************************
        ;// 
        ;//****************************************************************************************
        
      Case #PB_Event_Menu
        Select MenuID 
          Case #Shortcut_RecipeView_StartSearching    : SearchRecipes()
          Case #Shortcut_RecipeView_GetRecipes        : GetRecipeDirectory()
          Case #Shortcut_RecipeView_PrintRecipe       : ; ShowHelp("Recipeview")
          Case #Shortcut_RecipeView_ScreenSnap        : ToggleScreenSnap()
          Case #Shortcut_RecipeView_ToolTips          : ToggleTooltips()
          Case #Shortcut_RecipeView_TitleClock        : ToggleTitleClock()
          Case #Shortcut_RecipeView_StickyWindow      : ToggleStickyWindow()
          Case #Shortcut_RecipeView_HelpProgram       : ; PrintSelectedRecipe()
          Case #Shortcut_RecipeView_ExitProgram       : Program\QuitValue  = #True
        EndSelect
        
        ;//****************************************************************************************
        ;// 
        ;//****************************************************************************************
        
      Case #PB_Event_Gadget
        Select GadgetID
          Case #Gadget_Recipeview_Recipenames
            Select EventType()
              Case #PB_EventType_Change               : ShowRecipe()
            EndSelect
          Case #Gadget_Recipeview_Getdirectory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Getdirectory,   "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Getallrecipes")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_Getdirectory,   "Pressed") : GetRecipeDirectory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Getdirectory,   "Normal")
            EndSelect
          Case #Gadget_Recipeview_Printrecipe
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Printrecipe,    "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Printthisrecipe")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_Printrecipe,    "Pressed") : 
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Printrecipe,    "Normal")
            EndSelect
          Case #Gadget_Recipeview_ScreenSnap
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_ScreenSnap,     "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Screensnap")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_ScreenSnap,     "Pressed") : ToggleScreenSnap()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_ScreenSnap,     "Normal")
            EndSelect
          Case #Gadget_Recipeview_ToolTips
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_ToolTips,       "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Tooltips")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_ToolTips,       "Pressed") : ToggleTooltips()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_ToolTips,       "Normal")
            EndSelect
          Case #Gadget_Recipeview_TitleClock
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_TitleClock,     "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Titleclock")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_TitleClock,     "Pressed") : ToggleTitleClock()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_TitleClock,     "Normal")
            EndSelect
          Case #Gadget_Recipeview_StickyWindow
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_StickyWindow,   "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Stickywindow")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_StickyWindow,   "Pressed") : ToggleStickyWindow()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_StickyWindow,   "Normal")
            EndSelect
          Case #Gadget_Recipeview_Showhelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Showhelp,       "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Showprogramhelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_Showhelp,       "Pressed") : 
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Showhelp,       "Normal")
            EndSelect
          Case #Gadget_Recipeview_Exitprogram
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Exitprogram,    "Hovered") : StatusBarButtonTip(#Window_Recipeview, "Exitthisprogram")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Recipeview_Exitprogram,    "Pressed") : Program\QuitValue  = #True
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Recipeview_Exitprogram,    "Normal")
            EndSelect
        EndSelect
        
        ;//****************************************************************************************
        ;// 
        ;//****************************************************************************************
        
    EndSelect
    
    ;//********************************************************************************************
    ;// 
    ;//********************************************************************************************
    
  Until Program\QuitValue
  
  ;//**********************************************************************************************
  ;// 
  ;//**********************************************************************************************
  
  SavePreferencesFile()
  
  ;//**********************************************************************************************
  ;// 
  ;//**********************************************************************************************
  
  CloseWindow(#Window_Recipeview)
  
  ;//**********************************************************************************************
  ;// 
  ;//**********************************************************************************************
  
EndIf

;//************************************************************************************************
;// 
;//************************************************************************************************

End


; IDE Options = PureBasic 5.61 (Windows - x86)
; CursorPosition = 119
; FirstLine = 116
; EnableAsm
; EnableXP
; EnableCompileCount = 51
; EnableBuildCount = 0